import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { UserCardLog, UserCardLogParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询明细表
 */
export async function pageUserCardLog(params: UserCardLogParam) {
  const res = await request.get<ApiResult<PageResult<UserCardLog>>>(
    MODULES_API_URL + '/booking/user-card-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询明细表列表
 */
export async function listUserCardLog(params?: UserCardLogParam) {
  const res = await request.get<ApiResult<UserCardLog[]>>(
    MODULES_API_URL + '/booking/user-card-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加明细表
 */
export async function addUserCardLog(data: UserCardLog) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/user-card-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改明细表
 */
export async function updateUserCardLog(data: UserCardLog) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/user-card-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除明细表
 */
export async function removeUserCardLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/user-card-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除明细表
 */
export async function removeBatchUserCardLog(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/user-card-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询明细表
 */
export async function getUserCardLog(id: number) {
  const res = await request.get<ApiResult<UserCardLog>>(
    MODULES_API_URL + '/booking/user-card-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
